package com.sos.VirtualFileSystem.Interfaces;

import com.sos.JSHelper.interfaces.ISOSConnectionOptions;
import com.sos.JSHelper.interfaces.ISOSDataProviderOptions;
import com.sos.VirtualFileSystem.Options.SOSConnection2OptionsAlternate;

/**
* \class ISOSConnection
*
* \brief ISOSConnection -
*
* \details
*
* \section ISOSConnection.java_intro_sec Introduction
*
* \section ISOSConnection.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id$21.05.2010
* \see reference
*
* Created on 21.05.2010 10:58:41
 */

/**
 * @author KB
 *
 */
public interface ISOSConnection {

	/**
	 *
	 * \brief Connect
	 *
	 * \details
	 *
	 * \return ISOSConnection
	 *
	 * @return
	 * @throws Exception
	 */
	public ISOSConnection Connect() throws Exception;

	/**
	 *
	 * \brief Connect
	 *
	 * \details
	 *
	 * \return ISOSConnection
	 *
	 * @param pobjConnectionOptions
	 * @return
	 * @throws Exception
	 */
	public ISOSConnection Connect(SOSConnection2OptionsAlternate pobjConnectionOptions) throws Exception;

	public ISOSConnection Connect(ISOSDataProviderOptions pobjConnectionOptions) throws Exception;

	@Deprecated
	public ISOSConnection Connect(ISOSConnectionOptions pobjConnectionOptions) throws Exception;

	/**
	 *
	 * \brief Connect
	 *
	 * \details
	 *
	 * \return ISOSConnection
	 *
	 * @param pstrHostName
	 * @param pintPortNumber
	 * @return
	 * @throws Exception
	 */
	public ISOSConnection Connect(final String pstrHostName, final int pintPortNumber) throws Exception;

	/**
	 *
	 * \brief Authenticate
	 *
	 * \details
	 *
	 * \return ISOSConnection
	 *
	 * @param pobjAO
	 * @return
	 * @throws Exception
	 */
	public ISOSConnection Authenticate(ISOSAuthenticationOptions pobjAO) throws Exception;

	/**
	 *
	 * \brief CloseConnection
	 *
	 * \details
	 *
	 * \return void
	 *
	 * @throws Exception
	 */
	public void CloseConnection() throws Exception;
}
