package com.sos.auth.shiro.db;

import java.io.File;
import java.util.List;

import org.hibernate.Query;
 
import com.sos.hibernate.layer.SOSHibernateDBLayer;


/**
 * 
 * \class SOSUserDBLayer \brief SOSUserDBLayer -
 * 
 * \details
 * 
 * \section SOSUserDBLayer.java_intro_sec Introduction
 * 
 * \section SOSUserDBLayer.java_samples Some Samples
 * 
 * \code .... code goes here ... \endcode
 * 
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 13.09.2011 \see reference
 * 
 * Created on 13.09.2011 14:40:18
 */

public class SOSUserDBLayer extends SOSHibernateDBLayer {

	@SuppressWarnings("unused")
	private final String conClassName = "SOSUserDBLayer";

	 
	private SOSUserFilter filter = null;

	public SOSUserDBLayer(final File configurationFile_) {
		super();
		this.setConfigurationFile(configurationFile_);
		resetFilter();
	}
 
	public void resetFilter() {
		filter = new SOSUserFilter();
		filter.setUserName("");
	}

	public int delete() {

		if (session== null) {
			beginTransaction();
		}

		String hql = "delete from SOSUserDBItem " + getWhere();

		Query query = session.createQuery(hql);

		if (filter.getUserName() != null && !filter.getUserName().equals("")) {
			query.setParameter("sosUserName", filter.getUserName());
		}
		 
		int row = query.executeUpdate();

		return row;
	}

 

	private String getWhere() {
		String where = "";
		String and = "";

	 

		if (filter.getUserName() != null	&& !filter.getUserName().equals("")) {
			where += and + " sosUserName = :sosUserName";
			and = " and ";
		}

		if (where.trim().equals("")) {

		} else {
			where = "where " + where;
		}
		return where;

	}

	public List<SOSUserDBItem> getSOSUserList(final int limit) {
		initSession();

		Query query = session.createQuery("from SOSUserDBItem " + getWhere() + filter.getOrderCriteria() + filter.getSortMode());
	 
		if (filter.getUserName() != null	&& !filter.getUserName().equals("")) {
			query.setParameter("sosUserName", filter.getUserName());
		}

		if (limit > 0) {
			query.setMaxResults(limit);
		}

		@SuppressWarnings("unchecked")
		List<SOSUserDBItem> sosUserList = query.list();
		return sosUserList;

	}

	  
    public void setFilter(SOSUserFilter filter) {
        this.filter = filter;
    }

    public SOSUserFilter getFilter() {
        return filter;
    }
 

}
