package com.sos.scheduler.model.objects;
import java.io.File;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.math.BigInteger;
import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlTransient;

import org.apache.log4j.Logger;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerHotFolder;
import com.sos.scheduler.model.SchedulerObjectFactory;

/**
* \class JSObjBase
*
* \brief JSObjBase -
*
* \details
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 03.02.2011 16:06:55
 */
@XmlTransient
public class JSObjBase implements Comparable<JSObjBase> {

    @XmlTransient
	private final String				conClassName			= "JSObjBase";

	private static final Logger			logger					= Logger.getLogger(JSObjBase.class);
	protected static final String		conEMPTY				= "";
	protected static final String		conNO					= "no";
	protected static final String		conYES					= "yes";

//	public static final String	conNO									= "no";
//	public static final String	conYES									= "yes";

	protected static final String	conHtmlBR	= "<br/>";

    @XmlTransient
	protected SchedulerObjectFactory	objFactory				= null;
    @XmlTransient
	private ISOSVirtualFile				hotFolderSrc			= null;
    @XmlTransient
	protected JAXBElement<JSObjBase>	objJAXBElement			= null;
	@XmlTransient
	private boolean						flgIsDirty				= false;

    @XmlTransient
	protected String					strFileNameExtension	= "";
    @XmlTransient
	protected ISOSVirtualFile			objVirtualFile			= null;

    @XmlTransient
	protected boolean					flgIsInit				= false;

	@XmlTransient
	public void setInit(final boolean flgF) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setInit";

		flgIsInit = flgF;

	} // private void setDirty

	//	@XmlTransient
	public boolean canUpdate() {
		return flgIsInit == false;
	}

	@XmlTransient
	public void setDirty(final boolean flgF) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setDirty";

		flgIsDirty = flgF;

	} // private void setDirty

	  public boolean isEmpty(final String value) {
	        return value == null || value.length() == 0;
	    }
	  
	 public void setDirty() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setDirty";

		flgIsDirty = true;

	} // private void setDirty

	public boolean isDirty() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::isDirty";

		return flgIsDirty;

	} // private boolean isDirty

	public JSObjBase() {
		//
	}

	public void setParent(final SchedulerObjectFactory objParent) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setParent";
		objFactory = objParent;
	} // private void setParent

	public Object unMarshal(final File pobjFile) {
		return objFactory.unMarshall(pobjFile);
	}

	public Object unMarshal(final InputStream pobjInputStream) {
		return objFactory.unMarshall(pobjInputStream);
	}

	public Object unMarshal(final String pobjString) {
		return objFactory.unMarshall(pobjString);
	}

	public Object unMarshal(final ISOSVirtualFile pobjVirtualFile) {
		return objFactory.unMarshall(pobjVirtualFile);
	}

	public Object marshal(final Object objO, final File objF) {
		return objFactory.marshal(objO, objF);
	}

	public Object marshal(final File objF) {
		Object objO = null;
		if (objJAXBElement == null) {
			objO = this;
		}
		else {
			objJAXBElement.setValue(this);
			objO = objJAXBElement;
		}
		return marshal(objO, objF);
	}

	public String marshal() {
		Object objO = null;
		if (objJAXBElement == null) {
			objO = this;
		}
		else {
			objJAXBElement.setValue(this);
			objO = objJAXBElement;
		}
		return objFactory.marshal(objO);
	}

	public Object toXMLFile(final Object objO, final ISOSVirtualFile pobjVirtualFile) {
		return objFactory.toXMLFile(objO, pobjVirtualFile);
	}

	public Object toXMLFile(final ISOSVirtualFile pobjVirtualFile) {
		Object objO = null;
		if (objJAXBElement == null) {
			objO = this;
		}
		else {
			objJAXBElement.setValue(this);
			objO = objJAXBElement;
		}
		return toXMLFile(objO, pobjVirtualFile);
	}

	public Object save() {
		return toXMLFile(hotFolderSrc);		
	}
	
	public Object saveAs(final String pstrSaveAsFileName) {
		// TODO implement saveAs
		return null;		
	}
	
	public Object Rename(final String pstrRenameFileName) {
		// TODO implement Rename
		return null;		
	}
	

	public Object toXMLFile() {
		return toXMLFile(hotFolderSrc);
	}

	public String toXMLString(final Object objO) {
		return objFactory.toXMLString(objO);
	}

	public String toXMLString() {
		String xmlString = null;
		if (objJAXBElement == null) {
			xmlString = objFactory.toXMLString(this);
		}
		else {
			objJAXBElement.setValue(this);
			xmlString = objFactory.toXMLString(objJAXBElement);
		}
		return xmlString;
	}

	@XmlTransient
	public void setHotFolderSrc(final ISOSVirtualFile pobjVirtualFile) {
		hotFolderSrc = pobjVirtualFile;
	}

	public ISOSVirtualFile getHotFolderSrc() {
		return hotFolderSrc;
	}

	@Override
	public int compareTo(final JSObjBase o) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::compareTo";
		int compareRet = 0;
		boolean thisIsFolder = this.getClass().getSimpleName().equals("SchedulerHotFolder");
		boolean oIsFolder = o instanceof SchedulerHotFolder;
		if (thisIsFolder && !oIsFolder) {
			compareRet = -1;
		}
		else
			if (!thisIsFolder && oIsFolder) {
				compareRet = 1;
			}
			else
				if (this.getHotFolderSrc() == null) {
					compareRet = 1;
				}
				else
					if (o.getHotFolderSrc() == null) {
						compareRet = -1;
					}
					else {
						String hotFolderSrcName1 = this.getHotFolderSrc().getName().toLowerCase();
						String hotFolderSrcName2 = o.getHotFolderSrc().getName().toLowerCase();
						compareRet = hotFolderSrcName1.compareTo(hotFolderSrcName2);
					}
		return compareRet;
	}

	/**
	 *
	 * \brief setObjectFieldsFrom
	 *
	 * \details
	 * set all fields of a subclass according to its superclass
	 *
	 * \return void
	 *
	 * @param origObj
	 */
	public void setObjectFieldsFrom(final JSObjBase origObj) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setObjectFieldsFrom";
		Field[] fields;
		Class<?> origClass = origObj.getClass();
		if (!origClass.isAssignableFrom(this.getClass())) {
			throw new JobSchedulerException(String.format("%1$s must be a subclass of %2$s", this.getClass().getName(), origClass.getName()));
		}
		fields = origClass.getDeclaredFields();
		for (Field field : fields) {
			try {
				// to see private and protected fields too
				field.setAccessible(true);
				if (field.isAccessible()) {
					// final fields couldn't set and throws IllegalAccessException
					// but that's ok because we don't want set final fields
					field.set(this, field.get(origObj));
				}
			}
			catch (IllegalArgumentException e) {
				logger.error("", new JobSchedulerException("IllegalArgumentException", e));
			}
			catch (IllegalAccessException e) {
				// this catch block is reached for final fields (that's ok)
			}
		}
	}

	public boolean getYesOrNo(final String yesOrNo) {
		if (yesOrNo != null) {
			String work = yesOrNo.toLowerCase();
			return work.equals("1") || work.equals("yes") || work.equals("true") || work.equals("ja");
		}
		return false;
	}

	public String setYesOrNo(final boolean pflgV) {
		if (pflgV == true) {
			return "yes";
		}
		else {
			return "no";
		}
	}

	public String getObjectName() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getJobName";

		String name = this.getHotFolderSrc().getName();
		int i = name.indexOf(strFileNameExtension);
		if (i != -1) {
			name = name.substring(0, name.indexOf(strFileNameExtension));
		}
		name = new File(name).getName();

		return name;

	} // private String getJobName

	public String getObjectNameAndTitle() {
		String strT = getObjectName();
		String strV = getTitle();
		if (strV != null && strV.isEmpty() == false) {
			strT += " - " + getTitle();
		}
		return strT;
	}

	public static String notNull(final String pstrS) {
		String strR = pstrS;
		if (strR == null) {
			strR = "";
		}
		return strR;
	}

	public String getTitle() {
		return "";
	}

	public boolean isEnabled() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::isEnabled";

		boolean flgT = true;
		// TODO implement canWrite()
		//		boolean flgT = getHotFolderSrc().canWrite();
		return flgT;
	} // private boolean isEnabled

	protected void changeSourceName(final String pstrName) {
		ISOSVirtualFile objF = getHotFolderSrc();
		if (objF != null) {
			String name = objF.getName();
			name = name.replace(getObjectName(), pstrName);
			ISOSVirtualFile objNF = objF.getHandler().getFileHandle(name);
			setHotFolderSrc(objNF);
		}
	}

	protected String avoidNull(final String pstrV) {
		if (pstrV == null) {
			return "";
		}
		return pstrV;
	}

	protected String BigInt2String(final BigInteger pbigI) {
		if (pbigI != null) {
			long lngT = pbigI.longValue();
			return String.valueOf(lngT);
		}
		return "";
	}

	protected BigInteger Int2BigInteger(final int pintVal) {
		return BigInteger.valueOf(pintVal);
	}

	protected String getQuoted(final String pstrVal) {
		return "\"" + pstrVal.trim() + "\"";
	}

	public static final String escapeHTML(final String s){
		   StringBuffer sb = new StringBuffer();
		   int n = s.length();
		   for (int i = 0; i < n; i++) {
		      char c = s.charAt(i);
		      switch (c) {
		         case '<': sb.append("&lt;"); break;
		         case '>': sb.append("&gt;"); break;
		         case '&': sb.append("&amp;"); break;
		         case '"': sb.append("&quot;"); break;
		         case '': sb.append("&agrave;");break;
		         case '': sb.append("&Agrave;");break;
		         case '': sb.append("&acirc;");break;
		         case '': sb.append("&Acirc;");break;
		         case '': sb.append("&auml;");break;
		         case '': sb.append("&Auml;");break;
		         case '': sb.append("&aring;");break;
		         case '': sb.append("&Aring;");break;
		         case '': sb.append("&aelig;");break;
		         case '': sb.append("&AElig;");break;
		         case '': sb.append("&ccedil;");break;
		         case '': sb.append("&Ccedil;");break;
		         case '': sb.append("&eacute;");break;
		         case '': sb.append("&Eacute;");break;
		         case '': sb.append("&egrave;");break;
		         case '': sb.append("&Egrave;");break;
		         case '': sb.append("&ecirc;");break;
		         case '': sb.append("&Ecirc;");break;
		         case '': sb.append("&euml;");break;
		         case '': sb.append("&Euml;");break;
		         case '': sb.append("&iuml;");break;
		         case '': sb.append("&Iuml;");break;
		         case '': sb.append("&ocirc;");break;
		         case '': sb.append("&Ocirc;");break;
		         case '': sb.append("&ouml;");break;
		         case '': sb.append("&Ouml;");break;
		         case '': sb.append("&oslash;");break;
		         case '': sb.append("&Oslash;");break;
		         case '': sb.append("&szlig;");break;
		         case '': sb.append("&ugrave;");break;
		         case '': sb.append("&Ugrave;");break;
		         case '': sb.append("&ucirc;");break;
		         case '': sb.append("&Ucirc;");break;
		         case '': sb.append("&uuml;");break;
		         case '': sb.append("&Uuml;");break;
		         case '': sb.append("&reg;");break;
		         case '': sb.append("&copy;");break;
		         case '': sb.append("&euro;"); break;
		         // be carefull with this one (non-breaking white space)
		         case ' ': sb.append("&nbsp;");break;

		         default:  sb.append(c); break;
		      }
		   }
		   return sb.toString();
		}

	protected String[] arrayListToStringArray (final List <String> pobjArray) {
		String[] strA = new String[pobjArray.size()];
		strA = pobjArray.toArray(strA);
		return strA;
	}


}
