package com.sos.scheduler.engine.kernel.folder

import com.sos.scheduler.engine.common.guice.GuiceImplicits._
import com.sos.scheduler.engine.cplusplus.runtime.{Sister, SisterType}
import com.sos.scheduler.engine.data.filebased.FileBasedType
import com.sos.scheduler.engine.data.folder.FolderPath
import com.sos.scheduler.engine.kernel.cppproxy.FolderC
import com.sos.scheduler.engine.kernel.filebased.FileBased
import com.sos.scheduler.engine.kernel.scheduler.HasInjector

final class Folder(
  protected[this] val cppProxy: FolderC,
  protected val subsystem: FolderSubsystem)
extends FileBased {

  type Path = FolderPath

  def stringToPath(o: String) = FolderPath(o)

  def fileBasedType = FileBasedType.folder

  def onCppProxyInvalidated(): Unit = {}
}


object Folder {
  final class Type extends SisterType[Folder, FolderC] {
    def sister(proxy: FolderC, context: Sister) = {
      val injector = context.asInstanceOf[HasInjector].injector
      new Folder(proxy, injector.instance[FolderSubsystem])
    }
  }
}
